import codepipeline = require('@aws-cdk/aws-codepipeline-api');
import cdk = require('@aws-cdk/cdk');
import { ProjectRef } from './project';
/**
 * Construction properties of the {@link PipelineBuildAction CodeBuild build CodePipeline Action}.
 */
export interface PipelineBuildActionProps extends codepipeline.CommonActionProps {
    /**
     * The source to use as input for this build
     */
    inputArtifact: codepipeline.Artifact;
    /**
     * The name of the build's output artifact
     */
    artifactName?: string;
    /**
     * The build project
     */
    project: ProjectRef;
}
/**
 * CodePipeline build Action that uses AWS CodeBuild.
 */
export declare class PipelineBuildAction extends codepipeline.BuildAction {
    constructor(parent: cdk.Construct, name: string, props: PipelineBuildActionProps);
}
