import { Construct, PolicyDocument } from '@aws-cdk/cdk';
import { QueueRef } from './queue-ref';
export interface QueuePolicyProps {
    /**
     * The set of queues this policy applies to.
     */
    queues: QueueRef[];
}
/**
 * Applies a policy to SQS queues.
 */
export declare class QueuePolicy extends Construct {
    /**
     * The IAM policy document for this policy.
     */
    readonly document: PolicyDocument;
    constructor(parent: Construct, name: string, props: QueuePolicyProps);
}
